package com.company.jmixtest.entity

import io.jmix.core.FileRef
import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.metamodel.annotation.InstanceName
import io.jmix.core.metamodel.annotation.JmixEntity
import io.jmix.core.metamodel.annotation.JmixProperty
import java.math.BigDecimal
import java.util.*
import javax.persistence.*
import javax.validation.constraints.NotNull

@JmixEntity
@Entity(name = "jt_TestEntity")
@Table(name = "JT_TESTE_NTITY")
open class TestEntity {
    @Id
    @Column(name = "ID", nullable = false)
    @JmixGeneratedValue
    var id: UUID? = null

    @Column(name = "USERNAME", nullable = false)
    var username: String? = null

    @JmixProperty
    @Column(name = "VALUE", nullable = false)
    var value: BigDecimal? = null

    @Column(name = "FILE_REF")
    var fileRef: FileRef? = null

    @Temporal(TemporalType.DATE)
    @Column(name = "TIME")
    var time: Date? = null

    @InstanceName
    fun instanceName(): String? {
        return String.format("%s %s", value, time)
    }

}
